#!/usr/bin/perl -w

package FileChooserDialog;

BEGIN {
    use src::MymoneyUI;
};


use strict;

#use Encode;
use utf8;
#use open ':utf8', ':std';

use Gtk2;
init Gtk2;
#use Gnome2;

use lib "./";


my $MyUI;
my %MyMoney;
my $retval;

sub run {
    my ($class, %params) = @_;

    $retval=0;    
    my $window=$class;
    $MyUI=$window;
    %MyMoney=@{$params{'cfg'}};
    my @mime_filter=();
    if(defined($params{'filter'})) {
        @mime_filter=@{$params{'filter'}};
    };
    $MyUI->{'action'}="open";
    if(defined($params{'action'})) {
        $MyUI->{'action'}=$params{'action'};
    };
    
    if($MyUI->{'action'} eq 'open') {
        $MyUI->FORM->{'fchooser'}=Gtk2::FileChooserWidget->new('GTK_FILE_CHOOSER_ACTION_OPEN');
        $MyUI->TOPLEVEL->set_title('Otevření souboru');
        $MyUI->FORM->{'button_ok'}->show;
        $MyUI->FORM->{'button_ulozit'}->hide;
    } else {
        $MyUI->FORM->{'fchooser'}=Gtk2::FileChooserWidget->new('GTK_FILE_CHOOSER_ACTION_SAVE');
        $MyUI->TOPLEVEL->set_title('Uložení souboru');
        $MyUI->FORM->{'button_ok'}->hide;
        $MyUI->FORM->{'button_ulozit'}->show;
    };
    $MyUI->FORM->{'fchooser'}->signal_connect("file_activated"=>"file_activated");
    $MyUI->FORM->{'fchooser'}->signal_connect("selection_changed"=>"selection_changed");
    $MyUI->FORM->{'fchooser'}->show_all;

        #$filter->add_mime_type ("image/png");
        #$filter->add_mime_type ("image/gif");
        #$filter->add_mime_type ("image/jpeg");
    
    if((@mime_filter)) {
        my $filter = Gtk2::FileFilter->new;
        foreach $_ (@mime_filter) {
            $filter->add_mime_type ($_);
        };
        $MyUI->FORM->{'fchooser'}->add_filter($filter);
    };
    $window->FORM->{'frame11'}->add($MyUI->FORM->{'fchooser'});

    $MyMoney{'MainCfg'}->window_open("FileChooserDialog",$MyUI->TOPLEVEL);
    $MyUI->selection_changed;
    $window->TOPLEVEL->show;
    Gtk2->main;
    return($retval);
};

sub on_button_close_clicked {
    $MyMoney{'MainCfg'}->window_close("FileChooserDialog",$MyUI->TOPLEVEL);
    $MyUI->TOPLEVEL->hide;
    Gtk2->main_quit;
};

sub on_FileChooserDialog_unrealize {
    $MyMoney{'MainCfg'}->window_close("FileChooserDialog",$MyUI->TOPLEVEL);
    Gtk2->main_quit;
};

sub on_button_ok_clicked {
    if($MyUI->FORM->{'fchooser'}->get_filename) {
        $MyMoney{'MainCfg'}->window_close("FileChooserDialog",$MyUI->TOPLEVEL);
        $MyUI->TOPLEVEL->hide;
        $retval=$MyUI->FORM->{'fchooser'}->get_filename;
        Gtk2->main_quit;
    };
};

sub selection_changed {
    if($MyUI->FORM->{'fchooser'}->get_filename) {
        if(-f $MyUI->FORM->{'fchooser'}->get_filename) {
            $MyUI->FORM->{'button_ok'}->set_sensitive(1);
        } else {
            $MyUI->FORM->{'button_ok'}->set_sensitive(0);
        };
    } else {
        $MyUI->FORM->{'button_ok'}->set_sensitive(0);
    };
};

sub file_activated {
    if($MyUI->FORM->{'fchooser'}->get_filename) {
        if(-f $MyUI->FORM->{'fchooser'}->get_filename) {
            $MyUI->on_button_ok_clicked;
        };
    };
};

1;
