#!/usr/bin/perl -w

package ProgressDialog;

BEGIN {
    use src::MymoneyUI;
};


use strict;


#use Encode;
use utf8;
#use open ':utf8', ':std';

use Gtk2;
init Gtk2;

use lib "./";

my $MyUI;

my $val=0;
my $steps=40;
my $callback;
my $callback_sub;
my $label;

sub run {
    my ($class, %params) = @_;

    $val=0;
    my $window=$class;
    $MyUI=$window;
    $window->FORM->{'ProgressDialog'}->set_title("Průběh");
    $window->TOPLEVEL->show;
    
    if($params{'steps'}) {
        $steps=$params{'steps'};
    };
    if($params{'callback'}) {
        $callback=$params{'callback'};
    };
    if($params{'callback_sub'}) {
        $callback_sub=$params{'callback_sub'};
    };
    if($params{'label'}) {
        $label=$params{'label'};
    };
    if($params{'toplabel'}) {
        $MyUI->set_label($params{'toplabel'});
    };
    my $timeout=30;
    if($params{'toplabel'}) {
        $timeout=$params{'timeout'};
    };
    Glib::Timeout->add ($timeout, \&increase_progress_timeout);
    Gtk2->main;
};

sub toplevel_hide    { shift->get_toplevel->hide    }
sub toplevel_close   { shift->get_toplevel->close   }
sub toplevel_destroy { shift->get_toplevel->destroy }

sub set_label {
    my($self, $text)=@_;
    $MyUI->FORM->{'progress_top_label'}->set_label($text);
};

sub set_progress_label {
    my($self, $text)=@_;
    $MyUI->FORM->{'progressbar1'}->set_text($text);
};

sub close {
    $MyUI->TOPLEVEL->hide;
    Gtk2->main_quit;
};

sub increase_progress_timeout {
        
    if($label) {
        my $percent=sprintf("%i %%",$val*(1/$steps)*100);
        $MyUI->set_progress_label($percent);
    };
    $MyUI->FORM->{'progressbar1'}->set_fraction($val*(1/$steps));
    if($val>=$steps) {
        $MyUI->close;
        return(0);
    };
    if($callback) {
        #$MyUI->FORM->{'progressbar1'}->pulse;
        if(!$callback->$callback_sub($MyUI,$val)) {
            $MyUI->close;
            return(0);
        };
    };
    $val++;
    return(1);
};

1;
