#!/usr/bin/perl -w

package TableDef;

use strict;

#use Encode;
use utf8;
#use open ':utf8', ':std';

use lib "./";


my %Table=();



########################################
#
#
#
#       Globalni  tabulky
#
#
#
########################################


# [field_name, default_value, data_type, attributs, key]

$Table{'g_Locks'}=[
	["id","0","bigint","auto_increment","primary"],
	["user_id","0","bigint"],
	["user_name","","varchar"],
	["time","0","bigint"],
	["pid","0","bigint"],
	["hostname","","varchar"],
	["tablename","","varchar"],
	["agenda_id","0","bigint"],
	["rok_id","0","bigint"],
	["tablekey","","varchar","","unique"]	#realtablename:primary_key_value
];

$Table{'g_Agenda'}=[
	["id","0","bigint","auto_increment","primary"],
	["nazev","","varchar",""],
	["ulice","","varchar",""],
	["mesto","","varchar",""],
	["psc","","varchar",""],
	["stat","","varchar",""],
	["stat_kod","","varchar",""],
	["ob_nazev","","varchar",""],
	["ob_ulice","","varchar",""],
	["ob_mesto","","varchar",""],
	["ob_psc","","varchar",""],
	["ob_stat","","varchar",""],
	["ob_stat_kod","","varchar",""],
	["ico","","varchar",""],
	["dic","","varchar",""],
	["ean_kod","","varchar",""],
	["typ_subjektu","S","enum","SNP"],
	["typ_subjektu2","F","enum","FP"],
	["tel_pred","","varchar",""],
	["tel","","varchar",""],
	["tel_klapka","","varchar",""],
	["fax_pred","","varchar",""],
	["fax","","varchar",""],
	["fax_klapka","","varchar",""],
	["mobil_pred","","varchar",""],
	["mobil","","varchar",""],
	["email","","varchar",""],
	["www","","varchar",""],
	["jine_udaje","","text",""],
	["slozenky_sk","","varchar",""],
	["slozenky_tk","","varchar",""],
	["aktualni_spis","0","bigint",""],
	["adresar_dup_ico","0","bool",""],
	["adresar_dup_dic","0","bool",""],
	["adresar_dup_nazev","0","bool",""],
	["adresar_dup_nazev_len","0","int",""],
	["duplicita_kodu_f","0","enum","0HN"],
	["duplicita_kodu_o","0","enum","0HN"]
];

$Table{'g_Rok'}=[
	["id","0","bigint","auto_increment","primary"],
	["agenda_id","0","bigint",""],
	["ucetni_rok","0","int",""],
	["zacatek_roku","","date",""],
	["konec_roku","","date",""],
	["platce_dph","1","bool",""],
	["zakladni_sazba_dph","0","decimal",""],
	["snizena_sazba_dph","0","decimal",""],
	["splatnost_zavazku","0","int",""],
	["splatnost_pohledavek","0","int",""],
	["max_odchylka_dph_m","A","enum","AR"],
	["max_odchylka_dph","0","bigint",""],
	["typ_ucetnictvi","P","enum","JP"],
	["symbol_meny","","varchar",""],
	["kod_meny","","varchar",""],
	["pouzivat_cizi_meny","0","bool",""],
	["vest_intrastat","0","bool",""],
	["kontr_uc_pripadu","1","bool",""],
	["kontr_uc_pripadu_akce","1","int",""],
	["kontr_zdan_plneni","1","bool",""],
	["kontr_zdan_plneni_akce","1","int",""],
	["u_pokl_zaokr_vyd_dph","0","int",""],
	["u_pokl_zaokr_vyd_dph_m","2","int",""],
	["u_pokl_zaokr_prij_dph","1","int",""],
	["u_pokl_zaokr_prij_dph_m","2","int",""],
	["u_pokl_zaokr_vyd_celk","0","int",""],
	["u_pokl_zaokr_vyd_celk_m","2","int",""],
	["u_pokl_zaokr_vyd_rozp","1","int",""],
	["u_pokl_zaokr_prij_celk","1","int",""],
	["u_pokl_zaokr_prij_celk_m","0","int",""],
	["u_pokl_zaokr_prij_rozp","1","int",""],
	["u_b_zaokr_vyd_dph","0","int",""],
	["u_b_zaokr_vyd_dph_m","2","int",""],
	["u_b_zaokr_prij_dph","0","int",""],
	["u_b_zaokr_prij_dph_m","2","int",""],
	["u_b_zaokr_vyd_celk","0","int",""],
	["u_b_zaokr_vyd_celk_m","2","int",""],
	["u_b_zaokr_prij_celk","0","int",""],
	["u_b_zaokr_prij_celk_m","2","int",""],
	["u_zp_zaokr_zav_dph","0","int",""],
	["u_zp_zaokr_zav_dph_m","2","int",""],
	["u_zp_zaokr_poh_dph","1","int",""],
	["u_zp_zaokr_poh_dph_m","0","int",""],
	["u_zp_zaokr_zav_celk","0","int",""],
	["u_zp_zaokr_zav_celk_m","2","int",""],
	["u_zp_zaokr_poh_celk","1","int",""],
	["u_zp_zaokr_poh_celk_m","0","int",""],
	["u_zp_tolerovano_po_spl","0","int",""],
	["u_kr_generovat_i_d","1","bool",""],
	["u_kr_prebirat_protiucet","0","bool",""],
	["u_kr_kztrata_zav","","varchar",""],
	["u_kr_kztrata_poh","","varchar",""],
	["u_kr_kztrata_pf","","varchar",""],
	["u_kr_kztrata_vf","","varchar",""],
	["u_kr_kzisk_zav","","varchar",""],
	["u_kr_kzisk_poh","","varchar",""],
	["u_kr_kzisk_pf","","varchar",""],
	["u_kr_kzisk_vf","","varchar",""],
	["u_kr_kztrata_odzal_pf","","varchar",""],
	["u_kr_kztrata_odzal_vf","","varchar",""],
	["u_kr_kzisk_odzal_pf","","varchar",""],
	["u_kr_kzisk_odzal_vf","","varchar",""],
	["u_int_zaokr_dph","0","int",""],
	["u_int_zaokr_dph_m","2","int",""],
	["u_int_zaokr_celk","0","int",""],
	["u_int_zaokr_celk_m","2","int",""],
	["u_uzav_pur","","varchar",""],
	["u_uzav_kur","","varchar",""],
	["u_uzav_uzz","","varchar",""],
	["u_uzav_uhv","","varchar",""],
	["u_rch_sn_text","","varchar",""],
	["u_rch_sn_predkontace","","varchar",""],
	["u_rch_sn_cleneni","","varchar",""],
	["u_rch_sn_narok_text","","varchar",""],
	["u_rch_sn_narok_predkontace","","varchar",""],
	["u_rch_sn_narok_cleneni","","varchar",""],
	["u_rch_sn_typ_dokl","","varchar",""],
	["u_rch_bn_text","","varchar",""],
	["u_rch_bn_predkontace","","varchar",""],
	["u_rch_bn_cleneni","","varchar",""],
	["u_rch_bn_typ_dokl","","varchar",""],
	["dan_prav","0","decimal",""],
	["dan_fyz_0_od","0","bigint",""],
	["dan_fyz_0","0","decimal",""],
	["dan_fyz_1_od","0","bigint",""],
	["dan_fyz_1_do","0","bigint",""],
	["dan_fyz_1","0","decimal",""],
	["dan_fyz_2_od","0","bigint",""],
	["dan_fyz_2_do","0","bigint",""],
	["dan_fyz_2","0","decimal",""],
	["dan_fyz_3_od","0","bigint",""],
	["dan_fyz_3_do","0","bigint",""],
	["dan_fyz_3","0","decimal",""],
	["dan_fyz_4_od","0","bigint",""],
	["dan_fyz_4_do","0","bigint",""],
	["dan_fyz_4","0","decimal",""],
	["dan_fyz_5_od","0","bigint",""],
	["dan_fyz_5","0","decimal",""],
	["fak_p_zaokr_dph","0","int",""],
	["fak_p_zaokr_dph_m","2","int",""],
	["fak_p_zaokr_celk","0","int",""],
	["fak_p_zaokr_celk_m","2","int",""],
	["fak_p_zaokr_celk_rozp","1","int",""],
	["fak_p_vytvaret_sk_d","1","bool",""],
	["fak_v_zaokr_dph","0","int",""],
	["fak_v_zaokr_dph_m","2","int",""],
	["fak_v_zaokr_celk","0","int",""],
	["fak_v_zaokr_celk_m","2","int",""],
	["fak_v_vytvaret_sk_d","1","bool",""],
	["fak_odp_vf_uctproti","0","bool",""],
	["fak_odp_vf_text","","varchar",""],
	["fak_odp_vf_predkontace","","varchar",""],
	["fak_odp_vf_cleneni","","varchar",""],
	["fak_odp_pf_uctproti","0","bool",""],
	["fak_odp_pf_text","","varchar",""],
	["fak_odp_pf_predkontace","","varchar",""],
	["fak_odp_pf_cleneni","","varchar",""]
];

$Table{'g_Uzivatel'}=[
	["id","","bigint","auto_increment","primary"],
	["login","","varchar","","unique"],
	["password","","varchar"],
	["jmeno","","varchar"]
];

$Table{'g_Banky'}=[
	["nazev","","varchar","","unique"],
	["zkrat","","varchar","","unique"],
	["kod","","varchar","","primary"],
	["swift","","varchar"],
	["kodstatu","","varchar"]
];

$Table{'g_SzKonSym'}=[
	["konsym","","varchar","","primary"],
	["popis","","varchar"],
	["pozn","","text"]
];

$Table{'g_Psc'}=[
	["id","0","bigint","auto_increment","primary"],
	["misto","","varchar"],
	["psc","","varchar"],
	["posta","","varchar"],
	["telpred","","varchar"]
];

$Table{'g_Staty'}=[
        ["popis","","varchar","","unique"],
        ["kod","","varchar","","primary"],
        ["eu","0","bool"],
        ["koddic","","varchar"]
];


########################################
#
#
#
#        Tabulky roku
#
#
#
########################################

$Table{'r_UzivatelskeNastaveni'}=[
	["id","0","bigint","auto_increment","primary"],
	["user_id","0","bigint",""],
	["ucet","","varchar",""],
	["pokladna","","varchar",""],
	["stredisko","","varchar",""],
	["zakazka","","varchar",""],
	["cinnost","","varchar",""],
	["kontrola_uhrady","1","bool",""],
	["vyzadovat_potvrzeni","1","bool",""],
	["automaticka_zmena_data","Z","enum","ZA"],
	["dotaz_potvrdit","R","enum","RAZ"],
	["dotaz_potvrdit_po","0","int",""],
	["dotaz_zavrit_po","0","int",""],
	["znovu_se_zeptat_po","0","int",""],
	["up_vyd_predkontace","","varchar",""],
	["up_vyd_cleneni","","varchar",""],
	["up_vyd_ciselna_rada","","varchar",""],
	["up_vyd_nabidnout_zauc","0","bool",""],
	["up_vyd_nastaveni_typu_dok","P","enum","TPZ"],
	["up_vyd_typ_dokladu","","varchar",""],
	["up_vyd_tisk_dokl","1","bool",""],
	["up_vyd_tisk_dokl_text","Výdajový pokladní doklad","varchar",""],
	["up_vyd_tisk_dokl_se_zauc","0","bool",""],
	["up_vyd_tisk_dokl_se_zauc_text","Výdajový pokladní doklad","varchar",""],
	["up_vyd_tisk_danovy_dokl","0","bool",""],
	["up_vyd_tisk_danovy_dokl_text","Daňový doklad","varchar",""],
	["up_prij_predkontace","","varchar",""],
	["up_prij_cleneni","","varchar",""],
	["up_prij_ciselna_rada","","varchar",""],
	["up_prij_nabidnout_zauc","0","bool",""],
	["up_prij_nastaveni_typu_dok","P","enum","TPZ"],
	["up_prij_typ_dokladu","","varchar",""],
	["up_prij_tisk_dokl","1","bool",""],
	["up_prij_tisk_dokl_text","Příjmový pokladní doklad","varchar",""],
	["up_prij_tisk_dokl_se_zauc","0","bool",""],
	["up_prij_tisk_dokl_se_zauc_text","Příjmový pokladní doklad","varchar",""],
	["up_prij_tisk_danovy_dokl","0","bool",""],
	["up_prij_tisk_danovy_dokl_text","Daňový doklad","varchar",""],
	["ub_vyd_predkontace","","varchar",""],
	["ub_vyd_cleneni","","varchar",""],
	["ub_vyd_ciselna_rada","","varchar",""],
	["ub_vyd_nabidnout_zauc","0","bool",""],
	["ub_vyd_nastaveni_typu_dok","P","enum","TPZ"],
	["ub_vyd_typ_dokladu","","varchar",""],
	["ub_vyd_tisk_dokl","1","bool",""],
	["ub_vyd_tisk_dokl_text","Výdej z účtu","varchar",""],
	["ub_vyd_tisk_dokl_se_zauc","0","bool",""],
	["ub_vyd_tisk_dokl_se_zauc_text","Výdej z účtu","varchar",""],
	["ub_vyd_tisk_danovy_dokl","0","bool",""],
	["ub_vyd_tisk_danovy_dokl_text","Daňový doklad","varchar",""],
	["ub_prij_predkontace","","varchar",""],
	["ub_prij_cleneni","","varchar",""],
	["ub_prij_ciselna_rada","","varchar",""],
	["ub_prij_nabidnout_zauc","0","bool",""],
	["ub_prij_nastaveni_typu_dok","P","enum","TPZ"],
	["ub_prij_typ_dokladu","","varchar",""],
	["ub_prij_tisk_dokl","1","bool",""],
	["ub_prij_tisk_dokl_text","Příjem na účet","varchar",""],
	["ub_prij_tisk_dokl_se_zauc","0","bool",""],
	["ub_prij_tisk_dokl_se_zauc_text","Příjem na účet","varchar",""],
	["ub_prij_tisk_danovy_dokl","0","bool",""],
	["ub_prij_tisk_danovy_dokl_text","Daňový doklad","varchar",""],
	["uzp_zav_predkontace","","varchar",""],
	["uzp_zav_cleneni","","varchar",""],
	["uzp_zav_ciselna_rada","","varchar",""],
	["uzp_zav_nabidnout_zauc","0","bool",""],
	["uzp_zav_nastaveni_typu_dok","P","enum","TPZ"],
	["uzp_zav_typ_dokladu","","varchar",""],
	["uzp_zav_tisk_dokl","1","bool",""],
	["uzp_zav_tisk_dokl_text","Závazek","varchar",""],
	["uzp_zav_tisk_dokl_se_zauc","0","bool",""],
	["uzp_zav_tisk_dokl_se_zauc_text","Závazek","varchar",""],
	["uzp_zav_tisk_danovy_dokl","0","bool",""],
	["uzp_zav_tisk_danovy_dokl_text","Daňový doklad","varchar",""],
	["uzp_poh_predkontace","","varchar",""],
	["uzp_poh_cleneni","","varchar",""],
	["uzp_poh_ciselna_rada","","varchar",""],
	["uzp_poh_nabidnout_zauc","0","bool",""],
	["uzp_poh_nastaveni_typu_dok","P","enum","TPZ"],
	["uzp_poh_typ_dokladu","","varchar",""],
	["uzp_poh_tisk_dokl","1","bool",""],
	["uzp_poh_tisk_dokl_text","Pohledávka","varchar",""],
	["uzp_poh_tisk_dokl_se_zauc","0","bool",""],
	["uzp_poh_tisk_dokl_se_zauc_text","Pohledávka","varchar",""],
	["uzp_poh_tisk_danovy_dokl","0","bool",""],
	["uzp_poh_tisk_danovy_dokl_text","Daňový doklad","varchar",""],
	["ui_predkontace","","varchar",""],
	["ui_cleneni","","varchar",""],
	["ui_ciselna_rada","","varchar",""],
	["ui_nabidnout_zauc","1","bool",""],
	["ui_nastaveni_typu_dok","P","enum","TPZ"],
	["ui_typ_dokladu","","varchar",""],
	["ui_tisk_dokl","0","bool",""],
	["ui_tisk_dokl_text","Interní doklad","varchar",""],
	["ui_tisk_dokl_se_zauc","1","bool",""],
	["ui_tisk_dokl_se_zauc_text","Interní doklad","varchar",""],
	["ui_tisk_danovy_dokl","0","bool",""],
	["ui_tisk_danovy_dokl_text","Daňový doklad","varchar",""],
	["uk_cleneni","","varchar",""],
	["uk_ciselna_rada","","varchar",""],
	["uk_nabidnout_zauc","0","bool",""],
	["uk_tisk_dokl","0","bool",""],
	["uk_tisk_dokl_text","Interní doklad","varchar",""],
	["uk_tisk_dokl_se_zauc","0","bool",""],
	["uk_tisk_dokl_se_zauc_text","Interní doklad","varchar",""],
	["uk_tisk_danovy_dokl","0","bool",""],
	["uk_tisk_danovy_dokl_text","Daňový doklad","varchar",""],
	["uk_kurzova_ztrata_predkontace","","varchar"],
	["uk_kurzovy_zisk_predkontace","","varchar"],
	["fz_vyd_predkontace","","varchar",""],
	["fz_vyd_cleneni","","varchar",""],
	["fz_vyd_ciselna_rada","","varchar",""],
	["fz_vyd_nabidnout_zauc","0","bool",""],
	["fz_vyd_nastaveni_typu_dok","P","enum","TPZ"],
	["fz_vyd_typ_dokladu","","varchar",""],
	["fz_prij_predkontace","","varchar",""],
	["fz_prij_cleneni","","varchar",""],
	["fz_prij_ciselna_rada","","varchar",""],
	["fz_prij_nabidnout_zauc","0","bool",""],
	["fz_prij_nastaveni_typu_dok","P","enum","TPZ"],
	["fz_prij_typ_dokladu","","varchar",""],
	["fp_vyd_vytvorit_dokl","0","bool",""],
	["fp_vyd_nabidnout_dokl","0","bool",""],
	["fp_vyd_predkontace","","varchar",""],
	["fp_vyd_cleneni","","varchar",""],
	["fp_vyd_ciselna_rada","","varchar",""],
	["fp_prij_vytvorit_dokl","0","bool",""],
	["fp_prij_nabidnout_dokl","0","bool",""],
	["fp_prij_predkontace","","varchar",""],
	["fp_prij_cleneni","","varchar",""],
	["fp_prij_ciselna_rada","","varchar",""],
	["ft_vyd_fakturu","0","bool",""],
	["ft_vyd_fakturu_zauc","0","bool",""],
	["ft_vyd_danovy_dokl","0","bool",""],
	["ft_vyd_pokl_dokl","0","bool",""],
	["ft_prij_fakturu","0","bool",""],
	["ft_prij_fakturu_zauc","0","bool",""],
	["ft_prij_fakturu_dodav","0","bool",""],
	["ft_prij_danovy_dokl","0","bool",""],
	["ft_prij_dodaci_list","0","bool",""],
	["ft_prij_dodaci_list_dod","0","bool",""],
	["ft_prij_slozenku","0","bool",""],
	["ft_prij_dobirkovou_pruv","0","bool",""],
	["ft_prij_balikovou_pruv","0","bool",""],
	["ft_prij_pokl_dokl","0","bool",""],
	["fs_vyd_vytisknout","0","bool",""],
	["fs_vyd_pouzit_typ","S","enum","TPZS"],
	["fs_vyd_typ","","varchar",""],
	["fs_prij_vytisknout","0","bool",""],
	["fs_prij_pouzit_typ","S","enum","TPZS"],
	["fs_prij_typ","","varchar",""]
];

$Table{'r_SzUcPokl'}=[
	["zkrat","","varchar","","primary"],
	["popis","","varchar"],
	["ucpokl","","enum","UP"],
	["pocstav",0.00,"decimal"],
	["mena","","varchar"],
	["bmena","","varchar"],
	["primucet","","varchar"],
	["ucet","","varchar"],
	["bkod","","varchar"],
	["bnazev","","varchar"],
	["bzkrat","","varchar"],
	["uver","","bool"],
	["pokladni","","varchar"],
	["pozn","","text"],
	["pskurz","","decimal"],
	["psmnozstvi","0","int"],
	["iban","","varchar"],
	["swift","","varchar"]
];

$Table{'r_SzCinn'}=[
	["zkrat","","varchar","","primary"],
	["nazev","","varchar"],
	["pozn","","text"]
];

$Table{'r_SzStred'}=[
	["zkrat","","varchar","","primary"],
	["nazev","","varchar"],
	["pozn","","text"]
];

$Table{'r_Zakazky'}=[
	["zkrat","","varchar","","primary"],
	["nazev","","varchar"],
	["pozn","","text"]
];


$Table{'r_CisRady'}=[
	["rada","","varchar","","primary"],
	["cislo","1","int"],
	["nuly","","bool"],
	["pocetmist","5","int"],
	["nazev","","varchar"],
	["vf","0","bool"],
	["pf","0","bool"],
	["pp","0","bool"],
	["vp","0","bool"],
	["pu","0","bool"],
	["vu","0","bool"],
	["za","0","bool"],
	["po","0","bool"],
	["intd","0","bool"],
	["sj","0","bool"],
	["sv","0","bool"],
	["dl","0","bool"],
	["sm","0","bool"],
	["pd","0","bool"],
	["sd","0","bool"],
	["sa","0","bool"],
	["pz","0","bool"],
	["vo","0","bool"],
	["na","0","bool"],
	["np","0","bool"],
	["ptv","0","bool"],
	["ptp","0","bool"],
	["inv","0","bool"],
	["stred","","varchar"],
	["pozn","","text"]
];

$Table{'r_VolneCis'}=[
	["rada","","varchar"],
	["cislo","1","int"],
	["radacislo","","varchar","","primary"],
	["in_use","0","bigint"],
	["blokovano_uzivatelem","0","bigint"],
	["uzivatel","","varchar"],
	["nenab","","bool"]
];

$Table{'r_UcPrKont_P'}=[
	["zkrat","","varchar","","primary"],
	["typ","0","int"],
	["popis","","varchar"],
	["ucmd","000000","varchar","","key"],
	["ucd","000000","varchar","","key"],
	["zducmd","000000","varchar","","key"],
	["zducd","000000","varchar","","key"],
	["sducmd","000000","varchar","","key"],
	["sducd","000000","varchar","","key"],
	["uctovatled","0","bool"],
	["typceny","0","int"],
	["ucledmd","000000","varchar","","key"],
	["ucledd","000000","varchar","","key"],
	["cleneni","","varchar"],
	["pozn","","text"]
];

$Table{'r_UcPrKont_J'}=[
	["zkrat","","varchar","","primary"],
	["popis","","varchar"],
        ["typ","","enum","PV","key"],
	["pohzak","","varchar"],
	["pohdzs","","varchar"],
	["pohdss","","varchar"],
	["cleneni","","varchar"],
	["pozn","","text"]
];

$Table{'r_UcClnDPH'}=[
	["zkrat","","varchar","","primary"],
	["popis","","varchar"],
	["typ","P","enum","UP","key"],
	["kolonka","","varchar"],
	["kodplneni","0","int"],
	["bezodpoctu","0","bool"],
	["nokoef","0","bool"],
	["pozn","","text"]
];

$Table{'r_UcOsnova'}=[
	["ucet","","varchar","","primary"],
	["nazev","","varchar"],
	["ucprev","","varchar"],
	["pozn","","text"],
	["druhuctu","R","enum","RVZP"],
	["ucettyp","1","int"],
	["ucetpodtyp","1","int"],
	["vnitro","0","bool"],
	["technicky","0","bool"],
	["opravky","0","bool"]
];

$Table{'r_UcPohyby'}=[
	["zkrat","","varchar","","primary"],
	["popis","","varchar"],
	["typ","P","enum","PV"],
	["sloupec","","varchar"],
	["pozn","","text"]
];

$Table{'r_VFaktury'}=[
	["cislo","0","bigint","auto_increment","primary"],
	["doklad","","varchar","","key"],
	["storno","0","bigint","","key"],		#?
	["storno_t","-","enum","-SV","key"],	#stornotyp: - nic, Stornovany, stornoVaci
	["cisrada","","varchar"],
	["cisracislo","0","bigint"],
	["udoklad","","varchar"],	#?
	["popis","","varchar"],
	["odberatel","0","bigint"],	#id
	["o_nazev","","varchar"],
	["o_ulice","","varchar"],
	["o_mesto","","varchar"],
	["o_psc","","varchar"],
	["o_stat","","varchar"],
	["o_ico","","varchar"],
	["o_dic","","varchar"],
	["o_jmeno","","varchar"],
	["o_nazevob","","varchar"],
	["o_uliceob","","varchar"],
	["o_mestoob","","varchar"],
	["o_pscob","","varchar"],
	["o_statob","","varchar"],
	["konecprij","0","bigint"],	#id
	["k_nazev","","varchar"],
	["k_ulice","","varchar"],
	["k_mesto","","varchar"],
	["k_psc","","varchar"],
	["k_stat","","varchar"],
	["k_jmeno","","varchar"],
	["kpfromodb","0","bool"],	#?
	["d_nazev","","varchar"],
	["d_ulice","","varchar"],
	["d_mesto","","varchar"],
	["d_psc","","varchar"],
	["d_stat","","varchar"],
	["d_telpred","","varchar"],
	["d_telcislo","","varchar"],
	["d_telklap","","varchar"],
	["d_faxpred","","varchar"],
	["d_faxcislo","","varchar"],
	["d_faxklap","","varchar"],
	["d_mobilpre","","varchar"],
	["d_mobilcis","","varchar"],
	["d_email","","varchar"],
	["d_www","","varchar"],
	["d_ico","","varchar"],
	["d_dic","","varchar"],
	["d_nazevob","","varchar"],
	["d_uliceob","","varchar"],
	["d_mestoob","","varchar"],
	["d_pscob","","varchar"],
	["d_statob","","varchar"],
	["vystaveno","0001-01-01","date"],
	["datucpr","0001-01-01","date"],
	["plnenodph","0001-01-01","date"],
	["splatno","0001-01-01","date"],
	["uhrazeno","0001-01-01","date"],	#?
	["doruceno","0001-01-01","date"],
	["konsym","","varchar"],
	["cleneni","","varchar"],
	["zjednd","0","bool"],
	["varsymbol","","varchar"],
	["specsymbol","","varchar"],
	["parsymbol","","varchar"],
	["zakazka","","varchar"],
	["cobjednavky","","varchar"],
	["ucet","","varchar"],
	["druh","0","int"],		#normal, proforma, zaloha
	["dobropis","0","bool"],
	["cislouctu","","varchar"],
	["kodbanky","","varchar"],
	["nazevbanky","","varchar"],
	["zpdopravy","","text"],
	["uhrada","0","varchar"],	#hotove, prevodem, slozenkou, dobirkou, plkartou,zapoctem
	["predkontace","","varchar"],
	["cinnost","","varchar"],
	["sazbadph1","0","decimal"],
	["sazbadph2","0","decimal"],
	["kuhradesdp","0","decimal"],	# celkova cena faktury
	["proplatit","0","decimal"],	# castka, ktera jeste zbyva zaplatit
	["zaplaceno","0","decimal"],	# castka, ktera jiz byla zaplacena
	["vyuctovano","0","bool"],	#?
	["sleva","0","decimal"],
	["zaklad_0","0","decimal"],
	["zaklad_1","0","decimal"],
	["zaklad_2","0","decimal"],
	["zaklad_3","0","decimal"],
	["dph_1","0","decimal"],
	["dph_2","0","decimal"],
	["dph_3","0","decimal"],
	["korekcecen","0","bool"],
	["kzaklad_0","0","decimal"],
	["kzaklad_1","0","decimal"],
	["kzaklad_2","0","decimal"],
	["kdph_1","0","decimal"],
	["kdph_2","0","decimal"],
	["vystavil","","varchar"],
	["vystavil_id","0","bigint"],
	["datvyst","0001-01-01","date"],
	["casvyst","","varchar"],
	["prikuhrady","0001-01-01","date"],	#?
	["priuhrzbyv","0","decimal"],		#?
	["stredisko","","varchar"],
	["textpredfa","","text"],
	["textzafa","","text"],
	["textpreddl","","text"],
	["textzadl","","text"],
	["fdlpfromfa","0","bool"],		#?
	["fdlzfromfa","0","bool"],		#?
	["dateupom1","0001-01-01","date"],	#?
	["dateupom2","0001-01-01","date"],	#?
	["dateupoml","0001-01-01","date"],	#?
	["smazano","0","bool"],
	["datskpoh","0001-01-01","date"],
	["uzamceni","0","bool"],
	["sumzaloha","0","decimal"],		#?
	["sumzalohac","0","decimal"],		#?
	["typtrans","0","int"],
	["dodacipodm","0","int"],
	["druhdopr","0","int"],
	["dopravtuz","0","decimal"],
	["dopravzahr","0","decimal"],
	["datumits","0001-01-01","date"]
];

$Table{'r_VFaktPol'}=[
	["id","0","bigint","auto_increment","primary"],
	["faktura_cislo","0","bigint","","key"],
	["poradi","0","int"],
	["popis","","varchar"],
	["katalog","","varchar"],
	["cenamj","0","decimal"],
	["sleva","0","decimal"],
	["typceny","0","int"],
	["sazbadph","0.00","decimal"],
	["pocetmj","1.0000","decimal4"],
	["textmj","","varchar"],
	["mjzaklad","0","decimal4"],
	["mjdph","0","decimal4"],
	["mjvcdph","0","decimal4"],
	["celkemzaklad","0","decimal"],
	["celkemdph","0","decimal"],
	["celkemvcdph","0","decimal"],
	["predkontace","","varchar"],
	["zakazka","","varchar"],
	["cleneni","","varchar"],
	["cinnost","","varchar"],
	["stredisko","","varchar"],
	["zaruka","0","int"],
	["zaruka_n","0","int"],
	["pozn","","text"]
];

#$Table{'r_BankKnih'}=[
#	["cislo","","int","auto_increment","primary"],
#	["storno","","int"],
#	["vydej","","bool"],
#	["doklad","","varchar"],
#	["popis","","varchar"],
#	["datucpr","","date"],
#	["datvyst","","date"],
#	["datplat","","date"],
#	["datpln","","date"],
#	["vypis","","int"],
#	["idpolozky","","varchar"],
#	["varsym","","varchar"],
#	["parsym","","varchar"],
#	["konsym","","varchar"],
#	["specsym","","varchar"],
#	["adnazev","","varchar"],
#	["adulice","","varchar"],
#	["admesto","","varchar"],
#	["adpsc","","varchar"],
#	["adstat","","varchar"],
#	["adico","","varchar"],
#	["addic","","varchar"],
#	["ucet","","varchar"],
#	["prkont","","varchar"],
#	["cleneni","","varchar"],
#	["stred","","varchar"],
#	["zakazka","","varchar"],
#	["cinnost","","varchar"],
#	["ssazba","","decimal"],
#	["zsazba","","decimal"],
#	["zakl0","","decimal"],
#	["zaklss","","decimal"],
#	["dphss","","decimal"],
#	["zaklzs","","decimal"],
#	["dphzs","","decimal"],
#	["celkem","","decimal"],
#	["pozn","","text"],
#	["del","","bool"],
#	["drada","","varchar"],
#	["dcislo","","int"],
#	["adcislo","","int"],
#	["datpor","","date"],
#	["timpor","","varchar"],
#	["vyst","","varchar"],
#	["mena","","varchar"],
#	["pocetjedn","","int"],
#	["kurs","","decimal"],
#	["valutykuhr","","decimal"],
#	["valutyzak0","","decimal"],
#	["valutyzak1","","decimal"],
#	["valutyzak2","","decimal"],
#	["valutydph1","","decimal"],
#	["valutydph2","","decimal"],
#	["rezim","","int"],
#	["korekcecen","","bool"],
#	["noexpimp","","int"],
#	["slave","","int"],
#	["typop","","int"],
#	["typdokl","","varchar"],
#	["uzamceni","","bool"],
#	["aducet","","varchar"],
#	["adkod","","varchar"]
#];
#
#$Table{'r_IntDokl'}=[
#	["cislo","","int","auto_increment","primary"],
#	["storno","","int"],
#	["doklad","","varchar"],
#	["popis","","varchar"],
#	["datucpr","","date"],
#	["datpln","","date"],
#	["varsym","","varchar"],
#	["parsym","","varchar"],
#	["adnazev","","varchar"],
#	["adulice","","varchar"],
#	["admesto","","varchar"],
#	["adpsc","","varchar"],
#	["adstat","","varchar"],
#	["adico","","varchar"],
#	["addic","","varchar"],
#	["prkont","","varchar"],
#	["cleneni","","varchar"],
#	["stred","","varchar"],
#	["zakazka","","varchar"],
#	["cinnost","","varchar"],
#	["ssazba","","decimal"],
#	["zsazba","","decimal"],
#	["zakl0","","decimal"],
#	["zaklss","","decimal"],
#	["dphss","","decimal"],
#	["zaklzs","","decimal"],
#	["dphzs","","decimal"],
#	["celkem","","decimal"],
#	["del","","bool"],
#	["pozn","","text"],
#	["drada","","varchar"],
#	["dcislo","","int"],
#	["adcislo","","int"],
#	["datpor","","date"],
#	["timpor","","varchar"],
#	["vyst","","varchar"],
#	["mena","","varchar"],
#	["pocetjedn","","int"],
#	["kurs","","decimal"],
#	["valutykuhr","","decimal"],
#	["valutyzak0","","decimal"],
#	["valutyzak1","","decimal"],
#	["valutyzak2","","decimal"],
#	["valutydph1","","decimal"],
#	["valutydph2","","decimal"],
#	["rezim","","int"],
#	["korekcecen","","bool"],
#	["noexpimp","","int"],
#	["slave","","int"],
#	["typop","","int"],
#	["typdokl","","varchar"],
#	["uzamceni","","bool"]
#];
#
#$Table{'r_KnihPohl'}=[
#	["cislo","","int","auto_increment","primary"],
#	["storno","","int"],
#	["doklad","","varchar"],
#	["datucpr","","date"],
#	["datvyst","","date"],
#	["datspl","","date"],
#	["datpln","","date"],
#	["doruceno","","date"],
#	["popis","","varchar"],
#	["dbrpis","","bool"],
#	["cobjed","","varchar"],
#	["varsym","","varchar"],
#	["parsym","","varchar"],
#	["konsym","","varchar"],
#	["specsym","","varchar"],
#	["adnazev","","varchar"],
#	["adulice","","varchar"],
#	["admesto","","varchar"],
#	["adpsc","","varchar"],
#	["adstat","","varchar"],
#	["adico","","varchar"],
#	["addic","","varchar"],
#	["ucpokl","","varchar"],
#	["prkont","","varchar"],
#	["cleneni","","varchar"],
#	["stred","","varchar"],
#	["zakazka","","varchar"],
#	["cinnost","","varchar"],
#	["ssazba","","decimal"],
#	["zsazba","","decimal"],
#	["zakl0","","decimal"],
#	["zaklss","","decimal"],
#	["dphss","","decimal"],
#	["zaklzs","","decimal"],
#	["dphzs","","decimal"],
#	["celkem","","decimal"],
#	["uhzbyva","","decimal"],
#	["uhdatum","","date"],
#	["uhdokl","","varchar"],
#	["puzbyva","","decimal"],
#	["pudatum","","date"],
#	["pozn","","text"],
#	["datupom1","","date"],
#	["datupom2","","date"],
#	["datupoml","","date"],
#	["del","","bool"],
#	["drada","","varchar"],
#	["dcislo","","int"],
#	["adcislo","","int"],
#	["datpor","","date"],
#	["timpor","","varchar"],
#	["vyst","","varchar"],
#	["mena","","varchar"],
#	["pocetjedn","","int"],
#	["kurs","","decimal"],
#	["valutykuhr","","decimal"],
#	["valutyprop","","decimal"],
#	["valutyzak0","","decimal"],
#	["valutyzak1","","decimal"],
#	["valutyzak2","","decimal"],
#	["valutydph1","","decimal"],
#	["valutydph2","","decimal"],
#	["rezim","","int"],
#	["korekcecen","","bool"],
#	["noexpimp","","int"],
#	["slave","","int"],
#	["typop","","int"],
#	["typdokl","","varchar"],
#	["dummy","","bool"],
#	["uzamceni","","bool"]
#];
#
#$Table{'r_KnihZav'}=[
#	["cislo","","int","auto_increment","primary"],
#	["storno","","int"],
#	["doklad","","varchar"],
#	["datucpr","","date"],
#	["datvyst","","date"],
#	["datspl","","date"],
#	["datpln","","date"],
#	["doruceno","","date"],
#	["popis","","varchar"],
#	["dbrpis","","bool"],
#	["prdokl","","varchar"],
#	["varsym","","varchar"],
#	["parsym","","varchar"],
#	["konsym","","varchar"],
#	["specsym","","varchar"],
#	["adnazev","","varchar"],
#	["adulice","","varchar"],
#	["admesto","","varchar"],
#	["adpsc","","varchar"],
#	["adstat","","varchar"],
#	["adico","","varchar"],
#	["addic","","varchar"],
#	["ucpokl","","varchar"],
#	["prkont","","varchar"],
#	["cleneni","","varchar"],
#	["stred","","varchar"],
#	["zakazka","","varchar"],
#	["cinnost","","varchar"],
#	["ssazba","","decimal"],
#	["zsazba","","decimal"],
#	["zakl0","","decimal"],
#	["zaklss","","decimal"],
#	["dphss","","decimal"],
#	["zaklzs","","decimal"],
#	["dphzs","","decimal"],
#	["celkem","","decimal"],
#	["uhzbyva","","decimal"],
#	["uhdatum","","date"],
#	["uhdokl","","varchar"],
#	["puzbyva","","decimal"],
#	["pudatum","","date"],
#	["pozn","","text"],
#	["del","","bool"],
#	["drada","","varchar"],
#	["dcislo","","int"],
#	["adcislo","","int"],
#	["datpor","","date"],
#	["timpor","","varchar"],
#	["vyst","","varchar"],
#	["mena","","varchar"],
#	["pocetjedn","","int"],
#	["kurs","","decimal"],
#	["valutykuhr","","decimal"],
#	["valutyprop","","decimal"],
#	["valutyzak0","","decimal"],
#	["valutyzak1","","decimal"],
#	["valutyzak2","","decimal"],
#	["valutydph1","","decimal"],
#	["valutydph2","","decimal"],
#	["rezim","","int"],
#	["korekcecen","","bool"],
#	["noexpimp","","int"],
#	["slave","","int"],
#	["typop","","int"],
#	["dummy","","bool"],
#	["prozamest","","bool"],
#	["zamstrid","","varchar"],
#	["typpojis","","int"],
#	["smzsmesic","","int"],
#	["smzsrok","","int"],
#	["smzpkont","","varchar"],
#	["typdokl","","varchar"],
#	["uzamceni","","bool"],
#	["datupom1","","date"],
#	["datupom2","","date"],
#	["datupoml","","date"]
#];
#
#$Table{'r_PDUhrady'}=[
#	["poradi","","int","auto_increment","primary"],
#	["kontace","","varchar"],
#	["stredisko","","varchar"],
#	["zakazka","","varchar"],
#	["cinnost","","varchar"],
#	["zaklad","","decimal"],
#	["dphzs","","decimal"],
#	["dphss","","decimal"],
#	["wlzaklady","","decimal"],
#	["wldph1","","decimal"],
#	["wldph2","","decimal"]
#];
#
#$Table{'r_PFaktPol'}=[
#	["cislo","","int","auto_increment","primary"],
#	["cisloskpol","","int"],
#	["typepol","","int"],
#	["popis","","varchar"],
#	["poznamka","","text"],
#	["cislokat","","varchar"],
#	["textmj","","varchar"],
#	["pocetmj","","decimal"],
#	["sazbadph","","decimal"],
#	["cena","","decimal"],
#	["cenatyp","","int"],
#	["sleva","","decimal"],
#	["slevazakl","","decimal"],
#	["cinnost","","varchar"],
#	["poradi","","int"],
#	["koddph","","varchar"],
#	["stredisko","","varchar"],
#	["zakazka","","varchar"],
#	["predkontac","","varchar"],
#	["typzaruka","","bool"],
#	["zaruka","","int"],
#	["valuty","","decimal"],
#	["rozpust","","decimal"],
#	["dummy","","bool"],
#	["naklady","","bool"],
#	["zaloha","","bool"],
#	["cislozafak","","int"],
#	["rokzafak","","bool"],
#	["zfcastkav","","decimal"],
#	["kurzvd","","decimal"],
#	["pocetvd","","int"],
#	["bezidkurzr","","bool"],
#	["krporadi","","int"],
#	["protizapis","","bool"],
#	["typtrans","","bool"],
#	["kodstpuv","","bool"],
#	["hmotnost","","decimal"]
#];
#
#$Table{'r_PFaktTyp'}=[
#	["id","","bigint","auto_increment","primary"],
#	["zkratka","","varchar","","unique"],
#	["nazev","","varchar"],
#	["popis","","varchar"],
#	["nadfakt","","varchar"],
#	["nadfaktz","","varchar"],
#	["naddandokl","","varchar"],
#	["formfakt","","varchar"],
#	["formfaktz","","varchar"],
#	["formdand","","varchar"],
#	["rada","","varchar"],
#	["konstsym","","varchar"],
#	["koddph","","varchar"],
#	["ucet","","varchar"],
#	["druh","","bool"],
#	["dobropis","","bool"],
#	["sleva","","decimal"],
#	["flsplatnos","","bool"],
#	["splatnost","","int"],
#	["stredisko","","varchar"],
#	["pkontace","","varchar"],
#	["zakazka","","varchar"],
#	["cinnost","","varchar"],
#	["uhrada","","varchar"],
#	["mena","","varchar"],
#	["prfakt","","bool"],
#	["prfaktz","","bool"],
#	["prdandokl","","bool"],
#	["prpokldokl","","bool"],
#	["poznamka","","text"],
#	["typtrans","","bool"],
#	["dodacipodm","","bool"],
#	["druhdopr","","bool"]
#];
#
#$Table{'r_PFaktury'}=[
#	["cislo","","int","auto_increment","primary"],
#	["doklad","","varchar"],
#	["storno","","int"],
#	["rada","","varchar"],
#	["cisrada","","int"],
#	["udoklad","","varchar"],
#	["popis","","varchar"],
#	["dodavatel","","int"],
#	["d_nazev","","varchar"],
#	["d_ulice","","varchar"],
#	["d_mesto","","varchar"],
#	["d_psc","","varchar"],
#	["d_stat","","varchar"],
#	["d_ico","","varchar"],
#	["d_dic","","varchar"],
#	["d_jmeno","","varchar"],
#	["d_nazevob","","varchar"],
#	["d_uliceob","","varchar"],
#	["d_mestoob","","varchar"],
#	["d_pscob","","varchar"],
#	["d_statob","","varchar"],
#	["vystaveno","","date"],
#	["datucpr","","date"],
#	["plnenodph","","date"],
#	["splatno","","date"],
#	["uhrazeno","","date"],
#	["doruceno","","date"],
#	["konstsym","","varchar"],
#	["koddph","","varchar"],
#	["varsymbol","","varchar"],
#	["specsymbol","","varchar"],
#	["prijatdokl","","varchar"],
#	["parsymbol","","varchar"],
#	["zakazka","","varchar"],
#	["ucet","","varchar"],
#	["druh","","bool"],
#	["dobropis","","bool"],
#	["uhrada","","varchar"],
#	["predkontac","","varchar"],
#	["cinnost","","varchar"],
#	["sazbadph1","","decimal"],
#	["sazbadph2","","decimal"],
#	["kuhradesdp","","decimal"],
#	["proplatit","","decimal"],
#	["vyuctovano","","bool"],
#	["sleva","","decimal"],
#	["zaklad_0","","decimal"],
#	["zaklad_1","","decimal"],
#	["zaklad_2","","decimal"],
#	["dph_1","","decimal"],
#	["dph_2","","decimal"],
#	["korekcecen","","bool"],
#	["typ","","varchar"],
#	["vystavil","","varchar"],
#	["datvyst","","date"],
#	["casvyst","","varchar"],
#	["prikuhrady","","date"],
#	["priuhrzbyv","","decimal"],
#	["stredisko","","varchar"],
#	["flagdel","","bool"],
#	["mena","","varchar"],
#	["pocetjedn","","int"],
#	["kurs","","decimal"],
#	["valutykuhr","","decimal"],
#	["valutyprop","","decimal"],
#	["valutyzak0","","decimal"],
#	["valutyzak1","","decimal"],
#	["valutyzak2","","decimal"],
#	["valutydph1","","decimal"],
#	["valutydph2","","decimal"],
#	["noexpimp","","int"],
#	["slave","","int"],
#	["typop","","int"],
#	["dummy","","bool"],
#	["datskpoh","","date"],
#	["uzamceni","","bool"],
#	["sumzaloha","","decimal"],
#	["sumzalohac","","decimal"],
#	["dateupom1","","date"],
#	["dateupom2","","date"],
#	["dateupoml","","date"],
#	["poznamka","","text"],
#	["typtrans","","bool"],
#	["dodacipodm","","bool"],
#	["druhdopr","","bool"],
#	["dopravtuz","","decimal"],
#	["dopravzahr","","decimal"],
#	["datumits","","date"]
#];
#
#$Table{'r_PoklKnih'}=[
#	["cislo","","int","auto_increment","primary"],
#	["storno","","int"],
#	["zjednd","","bool"],
#	["doklad","","varchar"],
#	["datucpr","","date"],
#	["datvyst","","date"],
#	["datplat","","date"],
#	["datpln","","date"],
#	["pokl","","varchar"],
#	["stred","","varchar"],
#	["vydej","","bool"],
#	["prkont","","varchar"],
#	["cleneni","","varchar"],
#	["zakazka","","varchar"],
#	["cinnost","","varchar"],
#	["varsym","","varchar"],
#	["parsym","","varchar"],
#	["adnazev","","varchar"],
#	["adulice","","varchar"],
#	["admesto","","varchar"],
#	["adpsc","","varchar"],
#	["adstat","","varchar"],
#	["adico","","varchar"],
#	["addic","","varchar"],
#	["popis","","varchar"],
#	["ssazba","","decimal"],
#	["zsazba","","decimal"],
#	["zakl0","","decimal"],
#	["zaklss","","decimal"],
#	["dphss","","decimal"],
#	["zaklzs","","decimal"],
#	["dphzs","","decimal"],
#	["celkem","","decimal"],
#	["del","","bool"],
#	["pozn","","text"],
#	["drada","","varchar"],
#	["dcislo","","int"],
#	["adcislo","","int"],
#	["datpor","","date"],
#	["timpor","","varchar"],
#	["vyst","","varchar"],
#	["mena","","varchar"],
#	["pocetjedn","","int"],
#	["kurs","","decimal"],
#	["valutykuhr","","decimal"],
#	["valutyzak0","","decimal"],
#	["valutyzak1","","decimal"],
#	["valutyzak2","","decimal"],
#	["valutydph1","","decimal"],
#	["valutydph2","","decimal"],
#	["rezim","","int"],
#	["korekcecen","","bool"],
#	["noexpimp","","int"],
#	["slave","","int"],
#	["typop","","int"],
#	["typdokl","","varchar"],
#	["uzamceni","","bool"],
#	["version","","int"]
#];
#

sub get {
    my($table_hash)=@_;
    if(defined($Table{$table_hash})) {
	    return($Table{$table_hash});
    } else {
	print("TableDef->get: Error - neznama tabulka '".$table_hash."'!\n");
	exit
    };
};

sub get_table_names {
    return(keys(%Table));
};

1;
