#!/usr/bin/perl -w

package ZmenaAgendyRoku;

BEGIN {
    use src::MymoneyUI;
};


use strict;

#use Encode;
use utf8;
#use open ':utf8', ':std';

use Gtk2;
init Gtk2;
use Gtk2::SimpleList;
use Gnome2;

use lib "./";
use lib::Databaze;
use lib::NovaAgenda;
use lib::NastaveniAgendy;
use lib::NastaveniUcetnihoRoku;

my $MyUI;
my $retval;
my %MyMoney=();


my @agenda_id=();
my @rok_id=();

my $zvolena_agenda=0;
my $zvoleny_rok=0;

sub run {
    my ($class,%params) = @_;
    
    my $window=$class;
    %MyMoney=%params;
    
    $MyUI=$window;
    $retval=0;

    $window->TOPLEVEL->set_title('Změna agendy a roku');
    $window->FORM->{'slist_agenda'} = Gtk2::SimpleList->new('Agenda: '=>'text');
    $window->FORM->{'slist_agenda'}->get_selection->set_mode ('single');
    $window->FORM->{'slist_agenda'}->set_rules_hint(1);
    $window->FORM->{'slist_agenda'}->get_selection->signal_connect('changed',"on_agenda_selection_changed");
    $window->FORM->{'slist_agenda'}->show;
    $window->FORM->{'scrolledwindow10'}->add($window->FORM->{'slist_agenda'});

    $window->FORM->{'slist_rok'} = Gtk2::SimpleList->new('Rok: '=>'text');
    $window->FORM->{'slist_rok'}->get_selection->set_mode ('single');
    $window->FORM->{'slist_rok'}->set_rules_hint(1);
    $window->FORM->{'slist_rok'}->get_selection->signal_connect('changed',"on_rok_selection_changed");
    $window->FORM->{'slist_rok'}->show;
    $window->FORM->{'scrolledwindow9'}->add($window->FORM->{'slist_rok'});
    $MyUI->nacteni_seznamu;
 
    $MyMoney{'MainCfg'}->window_open("ZmenaAgendyRoku",$MyUI->TOPLEVEL);
    $window->TOPLEVEL->show;
    Gtk2->main;
    return($retval);
};

sub nacteni_seznamu {
    my $Databaze=new Databaze(%MyMoney);
    $Databaze->Read('g_Agenda',"",('id','ob_nazev'));
    my @agendy=();
    @agenda_id=();
    my $select_row=0;
    for(my $i=0;$i<$Databaze->numrows;$i++) {
        #$Databaze->dataseek($i);
        my %row=$Databaze->fetchhash;
        push(@agenda_id,$row{'id'});
        if($row{'id'} eq $MyMoney{'MainCfg'}->get('agenda')) {
            $select_row=$i;
        };
        push(@agendy,$row{'ob_nazev'});
    };
    $MyUI->FORM->{'slist_rok'}->get_selection->set_mode("none");
    @{$MyUI->FORM->{'slist_rok'}->{data}}=();
    $MyUI->FORM->{'slist_rok'}->get_selection->set_mode("single");

    $MyUI->FORM->{'slist_agenda'}->get_selection->set_mode("none");
    @{$MyUI->FORM->{'slist_agenda'}->{data}}=@agendy;
    $MyUI->FORM->{'slist_agenda'}->get_selection->set_mode("single");
    if(@agendy) {
        $MyUI->FORM->{'slist_agenda'}->get_selection->select_path(Gtk2::TreePath->new_from_indices ($select_row));
    } else {
        $MyUI->on_agenda_selection_changed;  
    };
};

sub toplevel_hide    { shift->get_toplevel->hide    }
sub toplevel_close   { shift->get_toplevel->close   }
sub toplevel_destroy { shift->get_toplevel->destroy }

sub on_ZmenaAgendyRoku_unrealize {
    $retval=0;
    $MyMoney{'MainCfg'}->window_close("ZmenaAgendyRoku",$MyUI->TOPLEVEL);
    Gtk2->main_quit;
};

sub on_button_ok_clicked {
    $retval=1;
    $MyMoney{'MainCfg'}->window_close("ZmenaAgendyRoku",$MyUI->TOPLEVEL);
    $MyUI->TOPLEVEL->hide;
    Gtk2->main_quit;
};

sub on_button_close_clicked {
    $retval=0;
    $MyMoney{'MainCfg'}->window_close("ZmenaAgendyRoku",$MyUI->TOPLEVEL);
    $MyUI->TOPLEVEL->hide;
    Gtk2->main_quit;
};

sub on_button_pridat_agendu_clicked {
    my $NovaAgenda=new NovaAgenda;
    $MyUI->TOPLEVEL->hide;
    if($NovaAgenda->run(%MyMoney)) {
        my %created=$NovaAgenda->get_created;
        $zvolena_agenda=$created{'agenda'};
        $zvoleny_rok=$created{'rok'};
        $retval=1;
        Gtk2->main_quit;
    } else {
        $MyUI->TOPLEVEL->show;
    };
};

sub on_button_pridat_rok_clicked {
    my $NovyUcetniRok=new NovyUcetniRok;
    $MyUI->TOPLEVEL->hide;
    my $vytvoreny_rok=$NovyUcetniRok->run($zvolena_agenda,%MyMoney);
    if($vytvoreny_rok) {
        $zvoleny_rok=$vytvoreny_rok;
        $retval=1;
        Gtk2->main_quit;
    } else {
        $MyUI->TOPLEVEL->show;
    };   
};

sub on_button_odstranit_agendu_clicked {
    if($zvolena_agenda eq $MyMoney{'AgendaData'}->get('id')) {
        my $Dialog=new Dialog;
        $Dialog->show('text'=>"Nemůžete smazat agendu, která je právě otevřena!",'type'=>'warning');
        return;
    };
    my $Agenda=new Table('g_Agenda',%MyMoney);
    $Agenda->load("id='".$zvolena_agenda."'");
    my $Dialog=new Dialog;
    if($Dialog->show('text'=>"Opravdu chcete smazat agendu '".$Agenda->get('ob_nazev')."'?",'type'=>'question')) {
        if($Dialog->show('text'=>"Opravdu chcete mazat? :-)",'type'=>'question')) {
            my $Databaze=new Databaze(%MyMoney);
            if($Databaze->odstranit_agendu($zvolena_agenda)) {
                my $Dialog=new Dialog;
                $Dialog->show('text'=>"Smazáno!",'type'=>'info');
                $MyUI->nacteni_seznamu;
            } else {
                my $Dialog=new Dialog;
                $Dialog->show('text'=>"Operace se nezdařila!\n\nZřejme byly některé tabulky uzamčeny jiným uživatelem.",'type'=>'error');
            };
        };
    };
};

sub on_button_odstranit_rok_clicked {
    if($zvoleny_rok eq $MyMoney{'RokData'}->get('id')) {
        my $Dialog=new Dialog;
        $Dialog->show('text'=>"Nemůžete smazat rok, který je právě otevřený!",'type'=>'warning');
        return;
    };
    my $Agenda=new Table('g_Agenda',%MyMoney);
    $Agenda->load("id='".$zvolena_agenda."'");
    my $Rok=new Table('g_Rok',%MyMoney);
    $Rok->load("id='".$zvoleny_rok."'");
    my $Dialog=new Dialog;
    if($Dialog->show('text'=>"Opravdu chcete smazat rok '".$Rok->get('ucetni_rok')."' z agendy '".$Agenda->get('ob_nazev')."'?",'type'=>'question')) {
        if($Dialog->show('text'=>"Opravdu chcete mazat? :-)",'type'=>'question')) {
            my $Databaze=new Databaze(%MyMoney);
            if($Databaze->odstranit_rok($zvoleny_rok)) {
                my $Dialog=new Dialog;
                $Dialog->show('text'=>"Smazáno!",'type'=>'info');
                $MyUI->nacteni_seznamu;
            } else {
                my $Dialog=new Dialog;
                $Dialog->show('text'=>"Operace se nezdařila!\n\nZřejme byly některé tabulky uzamčeny jiným uživatelem.",'type'=>'error');
            };
        };
    };
};

sub on_agenda_selection_changed {

    if($MyUI->FORM->{'slist_agenda'}->get_selection->count_selected_rows) {
        $MyUI->FORM->{'button_pridat_rok'}->set_sensitive(1);
        $MyUI->FORM->{'button_odstranit_agendu'}->set_sensitive(1);

        my $Databaze=new Databaze(%MyMoney);
        $zvolena_agenda=$agenda_id[$MyUI->FORM->{'slist_agenda'}->get_selection->get_selected_rows->get_indices];
        $Databaze->Read('g_Rok',"agenda_id='".$zvolena_agenda."'",('id','ucetni_rok'));
        my @roky=();
        @rok_id=();
        my $selected_row=0;
        for(my $i=0;$i<$Databaze->numrows;$i++) {
            #$Databaze->dataseek($i);
            my %row=$Databaze->fetchhash;
            push(@rok_id,$row{'id'});
            push(@roky,$row{'ucetni_rok'});
            if($row{'id'} eq $MyMoney{'MainCfg'}->get('rok')) {
                $selected_row=$i;
            };
        };
        $MyUI->FORM->{'slist_rok'}->get_selection->set_mode("none");
        @{$MyUI->FORM->{'slist_rok'}->{data}}=@roky;
        $MyUI->FORM->{'slist_rok'}->get_selection->set_mode("single");
        if(@roky) {
            $MyUI->FORM->{'slist_rok'}->get_selection->select_path(Gtk2::TreePath->new_from_indices ($selected_row));
        } else {
            $MyUI->on_rok_selection_changed;
        };
    } else {
        $MyUI->FORM->{'button_pridat_rok'}->set_sensitive(0);
        $MyUI->FORM->{'button_odstranit_agendu'}->set_sensitive(0);
        $MyUI->on_rok_selection_changed;
    };
};

sub on_rok_selection_changed {

    if($MyUI->FORM->{'slist_rok'}->get_selection->count_selected_rows) {
        $MyUI->FORM->{'slist_rok'}->get_selection->get_selected_rows->get_indices;
        $MyUI->FORM->{'button_ok'}->set_sensitive(1);
        $MyUI->FORM->{'button_odstranit_rok'}->set_sensitive(1);
        $zvoleny_rok=$rok_id[$MyUI->FORM->{'slist_rok'}->get_selection->get_selected_rows->get_indices];
    } else {
        $MyUI->FORM->{'button_ok'}->set_sensitive(0);
        $MyUI->FORM->{'button_odstranit_rok'}->set_sensitive(0);
    };
};

sub get_selected {
    return('agenda'=>$zvolena_agenda,'rok'=>$zvoleny_rok);
};

1;
